Subject: bug#10664: 24.0.93; JIT font-lock infloops in a C file

From: Eli Zaretskii <[email-masked]>
Date: Tue, 07 Feb 2012 19:30:17 +0200

> Date: Mon, 06 Feb 2012 19:04:17 +0200
> From: Eli Zaretskii <[email-masked]>
> Cc: [email-masked]
> 
> > Date: Mon, 6 Feb 2012 11:09:57 +0000
> > Cc: [email-masked]
> > From: Alan Mackenzie <[email-masked]>
> > 
> > I got something similar for this socket.c.  I load it into emacs -Q, then
> > start scrolling downwards, a page at a time.  The first five scrolls are
> > fine.  Then it hangs on the sixth.
> > 
> > However, typing C-g (maybe twice) frees it up, and it does the scroll.
> > Careful perusal reveals that the fontification is incomplete.  From now
> > on, most key sequences must be followed by C-g to perform their commands.
> > ;-(.
> > 
> > Did you actually try C-g when your session hung?
> 
> I'm quite sure I did.  But that was on Windows, where C-g is less
> powerful than on Posix platforms (since keyboard input is not
> interrupt driven).  So it could be that what you can interrupt on
> GNU/Linux, I cannot on Windows.

I'm now absolutely sure this is the case: the offending code runs with
inhibit-quit set, and that prevents Emacs on Windows from interrupting
that code.  I know because attaching GDB and using the debugger to set
inhibit-quit to nil breaks the vicious circle and let me salvage my
session without killing Emacs.

Btw, this time the problem happened with main.c from the recent Gawk
4.0.0h pre-release.